---
title: IDBFactory.open()
slug: Web/API/IDBFactory/open
tags:
  - API
  - Database
  - IDBFactory
  - IndexedDB
  - Method
  - Reference
  - Storage
  - open
---
<div>
<p>{{APIRef("IndexedDB")}}</p>
</div>

<div>
<p>The <strong><code>open()</code></strong> method of the {{domxref("IDBFactory")}} interface requests opening a <a href="/en-US/docs/IndexedDB#gloss_database_connection">connection to a database</a>.</p>

<p>The method returns an {{domxref("IDBOpenDBRequest")}} object immediately, and performs the open operation asynchronously. If the operation is successful, a <code>success</code> event is fired on the request object that is returned from this method, with its <code>result</code> attribute set to the new {{domxref("IDBDatabase")}} object for the connection.</p>
</div>

<p>If an error occurs while the database connection is being opened, then an <a href="/en-US/docs/IndexedDB/IDBErrorEvent">error event</a> is fired on the request object returned from this method.</p>

<p>May trigger <code>upgradeneeded</code>, <code>blocked</code> or <code>versionchange</code> events.</p>

<p>{{AvailableInWorkers}}</p>

<h2 id="Syntax">Syntax</h2>

<p>For the current standard:</p>

<pre class="syntaxbox" style="font-size: 14px;">var <em>IDBOpenDBRequest</em> = <em>indexedDB</em>.open(<em>name</em>);
var <em>IDBOpenDBRequest</em> = <em>indexedDB</em>.open(<em>name</em>, <em>version</em>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt>name</dt>
 <dd>The name of the database.</dd>
 <dt>version {{optional_inline}}</dt>
 <dd>Optional. The version to open the database with. If the version is not provided and the database exists, then a connection to the database will be opened without changing its version. If the version is not provided and the database does not exist, then it will be created with version <code>1</code>.</dd>
</dl>

<h4 id="Experimental_Gecko_options_object">Experimental Gecko options object</h4>

<dl>
 <dt>options (version and storage) {{optional_inline}} {{deprecated_inline}}</dt>
 <dd>In Gecko, since <a href="/en-US/Firefox/Releases/26">version 26</a>, you can include a non-standard <code>options</code> object as a parameter of {{ domxref("IDBFactory.open") }} that contains the <code>version</code> number of the database, plus a storage value that specifies whether you want to use <code>persistent</code> or <code>temporary</code> storage.
 <div class="warning"><strong>Warning:</strong> The <code>storage</code> attribute is deprecated and will soon be removed from Gecko. You should use {{domxref("StorageManager.persist()")}} to get persistent storage instead.</div>
 </dd>
</dl>

<div class="note">
<p><strong>Note</strong>: You can find out more information on the different available storage types, and how Firefox handles client-side data storage, at <a href="/en-US/docs/Web/API/IndexedDB_API/Browser_storage_limits_and_eviction_criteria">Browser storage limits and eviction criteria</a>.</p>
</div>

<h3 id="Return_value">Return value</h3>

<p>A {{domxref("IDBOpenDBRequest")}} object on which subsequent events related to this request are fired.</p>

<h3 id="Exceptions">Exceptions</h3>

<p>This method may raise a {{domxref("DOMException")}} of the following types:</p>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Exception</th>
   <th scope="col">Description</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><code>TypeError</code></td>
   <td>The value of version is zero or a negative number or not a number.</td>
  </tr>
 </tbody>
</table>

<h2 id="Example">Example</h2>

<p>Example of calling <code>open</code> with the current specification's <code>version</code> parameter:</p>

<pre class="brush: js" style="font-size: 14px;">var request = window.indexedDB.open("toDoList", 4);</pre>

<p>In the following code snippet, we make a request to open a database, and include handlers for the success and error cases. For a full working example, see our <a class="external" href="https://github.com/mdn/to-do-notifications/tree/gh-pages">To-do Notifications</a> app (<a class="external" href="https://mdn.github.io/to-do-notifications/">view example live</a>.)</p>

<pre class="brush:js">var note = document.querySelector("ul");

// In the following line, you should include the prefixes
// of implementations you want to test.
window.indexedDB = window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
// DON'T use "var indexedDB = ..." if you're not in a function.
// Moreover, you may need references to some window.IDB* objects:
window.IDBTransaction = window.IDBTransaction || window.webkitIDBTransaction || window.msIDBTransaction;
window.IDBKeyRange = window.IDBKeyRange || window.webkitIDBKeyRange || window.msIDBKeyRange;
// (Mozilla has never prefixed these objects, so we don't
//  need window.mozIDB*)

// Let us open version 4 of our database
var DBOpenRequest = window.indexedDB.open("toDoList", 4);

// these two event handlers act on the database being opened
// successfully, or not
DBOpenRequest.onerror = function(event) {
  note.innerHTML += '&lt;li&gt;Error loading database.&lt;/li&gt;';
};

DBOpenRequest.onsuccess = function(event) {
  note.innerHTML += '&lt;li&gt;Database initialised.&lt;/li&gt;';

  // store the result of opening the database in the db
  // variable. This is used a lot later on, for opening
  // transactions and suchlike.
  db = DBOpenRequest.result;
};
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('IndexedDB', '#dom-idbfactory-open', 'open()')}}</td>
   <td>{{Spec2('IndexedDB')}}</td>
   <td> </td>
  </tr>
  <tr>
   <td>{{SpecName("IndexedDB 2", "#dom-idbfactory-open", "open()")}}</td>
   <td>{{Spec2("IndexedDB 2")}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.IDBFactory.open")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/IndexedDB_API/Using_IndexedDB">Using IndexedDB</a></li>
 <li>Starting transactions: {{domxref("IDBDatabase")}}</li>
 <li>Using transactions: {{domxref("IDBTransaction")}}</li>
 <li>Setting a range of keys: {{domxref("IDBKeyRange")}}</li>
 <li>Retrieving and making changes to your data: {{domxref("IDBObjectStore")}}</li>
 <li>Using cursors: {{domxref("IDBCursor")}}</li>
 <li>Reference example: <a class="external" href="https://github.com/mdn/to-do-notifications/tree/gh-pages">To-do Notifications</a> (<a class="external" href="https://mdn.github.io/to-do-notifications/">view example live</a>.)</li>
</ul>
